upload-archive: allow user to turn off filters
[gitweb.git] / git-merge-octopus.sh
index bb58e22a18bdaefae3f8005e7b0a0cfaba4b4185..8643f74cb09f278c37851c418e839c7d160f36ca 100755 (executable)
@@ -8,6 +8,11 @@
 LF='
 '
 
+die () {
+    echo >&2 "$*"
+    exit 1
+}
+
 # The first parameters up to -- are merge bases; the rest are heads.
 bases= head= remotes= sep_seen=
 for arg
@@ -39,28 +44,38 @@ esac
 # MRC is the current "merge reference commit"
 # MRT is the current "merge result tree"
 
-MRC=$head MSG= PARENT="-p $head"
-MRT=$(git-write-tree)
-CNT=1 ;# counting our head
+MRC=$(git rev-parse --verify -q $head)
+MRT=$(git write-tree)
 NON_FF_MERGE=0
+OCTOPUS_FAILURE=0
 for SHA1 in $remotes
 do
-       common=$(git-merge-base --all $MRC $SHA1) ||
-               die "Unable to find common commit with $SHA1"
+       case "$OCTOPUS_FAILURE" in
+       1)
+               # We allow only last one to have a hand-resolvable
+               # conflicts.  Last round failed and we still had
+               # a head to merge.
+               echo "Automated merge did not work."
+               echo "Should not be doing an Octopus."
+               exit 2
+       esac
 
-       case "$common" in
-       ?*"$LF"?*)
-               die "Not trivially mergeable."
-               ;;
-       $SHA1)
-               echo "Already up-to-date with $SHA1"
+       eval pretty_name=\${GITHEAD_$SHA1:-$SHA1}
+       if test "$SHA1" = "$pretty_name"
+       then
+               SHA1_UP="$(echo "$SHA1" | tr a-z A-Z)"
+               eval pretty_name=\${GITHEAD_$SHA1_UP:-$pretty_name}
+       fi
+       common=$(git merge-base --all $SHA1 $MRC) ||
+               die "Unable to find common commit with $pretty_name"
+
+       case "$LF$common$LF" in
+       *"$LF$SHA1$LF"*)
+               echo "Already up-to-date with $pretty_name"
                continue
                ;;
        esac
 
-       CNT=`expr $CNT + 1`
-       PARENT="$PARENT -p $SHA1"
-
        if test "$common,$NON_FF_MERGE" = "$MRC,0"
        then
                # The first head being merged was a fast-forward.
@@ -68,34 +83,27 @@ do
                # tree as the intermediate result of the merge.
                # We still need to count this as part of the parent set.
 
-               echo "Fast forwarding to: $SHA1"
-               git-read-tree -u -m $head $SHA1 || exit
-               MRC=$SHA1 MRT=$(git-write-tree)
+               echo "Fast-forwarding to: $pretty_name"
+               git read-tree -u -m $head $SHA1 || exit
+               MRC=$SHA1 MRT=$(git write-tree)
                continue
        fi
 
        NON_FF_MERGE=1
 
-       echo "Trying simple merge with $SHA1"
-       git-read-tree -u -m $common $MRT $SHA1 || exit 2
-       next=$(git-write-tree 2>/dev/null)
+       echo "Trying simple merge with $pretty_name"
+       git read-tree -u -m --aggressive  $common $MRT $SHA1 || exit 2
+       next=$(git write-tree 2>/dev/null)
        if test $? -ne 0
        then
                echo "Simple merge did not work, trying automatic merge."
                git-merge-index -o git-merge-one-file -a ||
-               exit 2 ; # Automatic merge failed; should not be doing Octopus
-               next=$(git-write-tree 2>/dev/null)
+               OCTOPUS_FAILURE=1
+               next=$(git write-tree 2>/dev/null)
        fi
 
-       # We have merged the other branch successfully.  Ideally
-       # we could implement OR'ed heads in merge-base, and keep
-       # a list of commits we have merged so far in MRC to feed
-       # them to merge-base, but we approximate it by keep using
-       # the current MRC.  We used to update it to $common, which
-       # was incorrectly doing AND'ed merge-base here, which was
-       # unneeded.
-
+       MRC="$MRC $SHA1"
        MRT=$next
 done
 
-exit 0
+exit "$OCTOPUS_FAILURE"